# Why choose ZIAPI

## Modules

First of all **ZIAPI** offers a great deal of simplicity. Modules are separated into clearly defined groups (**network**, **pre-processor**, **post-processor**, **network**) and feature a wide variety of use cases.

Our best selling point is the long list of **example modules** that we have already implemented to help you understand our API better.

Here is a list of non-hexaustive list of modules you can very easily implement using **ZIAPI**.
- [Directory Listing](../examples/DIRECTORY_LISTING.md)
- Authentication
- Automatic MIME type detection
- Routing
- [Redirection](../examples/REDIRECTION.md)
- Secure connection module
- PHP CGI
- SSL / TLS
- HTTP Handler
- Database
- Benchmark
- Dashboard (frequency of requests, CPU load)
- [Logger](../examples/LOGGER.md)
- Compression / decompression

## Documentation

We have documented each and every one of our source files and added additional info on how to
- [Build and compile the project](../guides/INSTALL_AND_BUILD.md)
- Create modules (Numerous [code examples](../examples) of different common module and one [in-depth guide per module type](../guides))
- [Contributing](CONTRIBUTING.md)

## Additional tools

We've built an amazing [website](https://ziapi.vercel.app) for you to navigate the docs more easily.

With the API, we also included our own Open-Source and unit-tested [dynamic library loader](https://github.com/martin-olivier/dylib) developped by [Martin Olivier](https://github.com/martin-olivier).
